# FilterChain

Extends \DataType

FilterChain may contain a chained set of filter readers.

This class handles the common description attribute and provides a default implementation for reference handling and checking for circular references that is appropriate for types that can not be nested inside elements of the same type (i.e. patternset but not path)

author | Yannick Lecaillez yl@seasonfive.com
version | $Id: d35bf0481e55f713cf67a71878d978f224baa05e $
package | phing.types

### Methods

## __construct

    __construct(null $project = null)

### Arguments

#### $project

`null`

## addConcatFilter

    addConcatFilter(\ConcatFilter $o)

### Arguments

#### $o

`\ConcatFilter`

## addEscapeUnicode

    addEscapeUnicode(\PrefixLines $o)

### Arguments

#### $o

`\PrefixLines`

## addExpandProperties

    addExpandProperties(\ExpandProperties $o)

### Arguments

#### $o

`\ExpandProperties`

## addFilterReader

    addFilterReader(\PhingFilterReader $o)

### Arguments

#### $o

`\PhingFilterReader`

## addGettext

    addGettext(\TranslateGettext $o)

### Arguments

#### $o

`\TranslateGettext`

## addHeadFilter

    addHeadFilter(\HeadFilter $o)

### Arguments

#### $o

`\HeadFilter`

## addIconvFilter

    addIconvFilter(\IconvFilter $o)

### Arguments

#### $o

`\IconvFilter`

## addLineContains

    addLineContains(\LineContains $o)

### Arguments

#### $o

`\LineContains`

## addLineContainsRegExp

    addLineContainsRegExp(\LineContainsRegexp $o)

### Arguments

#### $o

`\LineContainsRegexp`

## addPhpArrayMapLines

    addPhpArrayMapLines(\PhpArrayMapLines $o)

### Arguments

#### $o

`\PhpArrayMapLines`

## addPrefixLines

    addPrefixLines(\PrefixLines $o)

### Arguments

#### $o

`\PrefixLines`

## addReplaceRegexp

    addReplaceRegexp(\ReplaceRegexp $o)

### Arguments

#### $o

`\ReplaceRegexp`

## addReplaceTokens

    addReplaceTokens(\ReplaceTokens $o)

### Arguments

#### $o

`\ReplaceTokens`

## addReplaceTokensWithFile

    addReplaceTokensWithFile(\ReplaceTokensWithFile $o)

### Arguments

#### $o

`\ReplaceTokensWithFile`

## addSortFilter

    addSortFilter(\SortFilter $o)

### Arguments

#### $o

`\SortFilter`

## addStripLineBreaks

    addStripLineBreaks(\StripLineBreaks $o)

### Arguments

#### $o

`\StripLineBreaks`

## addStripLineComments

    addStripLineComments(\StripLineComments $o)

### Arguments

#### $o

`\StripLineComments`

## addStripPhpComments

    addStripPhpComments(\StripPhpComments $o)

### Arguments

#### $o

`\StripPhpComments`

## addStripWhitespace

    addStripWhitespace(\StripWhitespace $o)

### Arguments

#### $o

`\StripWhitespace`

## addSuffixLines

    addSuffixLines(\SuffixLines $o)

### Arguments

#### $o

`\SuffixLines`

## addTabToSpaces

    addTabToSpaces(\TabToSpaces $o)

### Arguments

#### $o

`\TabToSpaces`

## addTailFilter

    addTailFilter(\TailFilter $o)

### Arguments

#### $o

`\TailFilter`

## addTidyFilter

    addTidyFilter(\TidyFilter $o)

### Arguments

#### $o

`\TidyFilter`

## addXincludeFilter

    addXincludeFilter(\XincludeFilter $o)

### Arguments

#### $o

`\XincludeFilter`

## addXsltFilter

    addXsltFilter(\XsltFilter $o)

### Arguments

#### $o

`\XsltFilter`

## Creates an exception that indicates the user has generated a loop of data types referencing each other.

    circularReference() : \BuildException

inherited

### Response

`\BuildException`

## Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

    dieOnCircularReference( &$stk, \Project $p) : void

inherited

If one is included, throw a BuildException created by circularReference

This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

The general contract of this method is that it shouldn't do anything if checked is true and set it to true on exit.

throws |

### Arguments

#### $stk

``

#### $p

`\Project`

## Performs the check for circular references and returns the referenced object.

    getCheckedRef( $requiredClass,  $dataTypeName) : mixed

inherited

throws |

### Arguments

#### $requiredClass

``

#### $dataTypeName

``

### Response

`mixed`

## Return the description for the current data type.

    getDescription()

inherited

retujrn | string

## getFilterReaders

    getFilterReaders() : array

### Response

`array`

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Has the refid attribute of this element been set?

    isReference() : boolean

inherited

### Response

`boolean`

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.

    noChildrenAllowed() : \BuildException

inherited

### Response

`\BuildException`

## Template method being called when the data type has been parsed completely.

    parsingComplete() : void

inherited

{@inheritdoc}

## pushAndInvokeCircularReferenceCheck

    pushAndInvokeCircularReferenceCheck(\DataType $dt,  &$stk, \Project $p)

inherited static

### Arguments

#### $dt

`\DataType`

#### $stk

``

#### $p

`\Project`

## Sets a description of the current data type. It will be useful in commenting what we are doing.

    setDescription(string $desc) : void

inherited

### Arguments

#### $desc

`string`

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Set the value of the refid attribute.

    setRefid(\Reference $r) : void

inherited

Subclasses may need to check whether any other attributes have been set as well or child elements have been created and thus override this method. if they do they must call parent::setRefid()

### Arguments

#### $r

`\Reference`

## Creates an exception that indicates that refid has to be the only attribute if it is set.

    tooManyAttributes() : \BuildException

inherited

### Response

`\BuildException`

### Properties

## filterReaders

    filterReaders :

### Type(s)

``

## The descriptin the user has set.

    description : string

inherited

var |

### Type(s)

`string`

## Value to the refid attribute.

    ref : \Reference

inherited

var |

### Type(s)

`\Reference`

## Are we sure we don't hold circular references?

    checked : boolean

inherited

Subclasses are responsible for setting this value to false if we'd need to investigate this condition (usually because a child element has been added that is a subclass of DataType).

var |

### Type(s)

`boolean`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`